package rocks.zipcode.quiz5.objectorientation.account;

/**
 * @author leon on 27/12/2018.
 */
public class BankAccount extends Account implements Transactable{
    private Double balance;
    private Long id;

    public BankAccount(Double balance, Long id) {
        this.balance = balance;
        this.id = id;
    }

    public BankAccount() {
        this.balance = 0.0;
    }

    public void setBalance(Double val) {
        this.balance = val;
    }

    @Override
    public void deposit(Double amountToIncreaseBy) {
        if(amountToIncreaseBy<=0){
            throw new IllegalArgumentException();
        }
        balance = balance+amountToIncreaseBy;
    }

    @Override
    public void withdrawal(Double amountToDecreaseBy) {
        if(amountToDecreaseBy>balance){
            throw new IllegalArgumentException();
        }else if(amountToDecreaseBy<0){
            throw new IllegalArgumentException();
        }
        balance = balance-amountToDecreaseBy;
    }

    @Override
    public Double getBalance() {
        return balance;
    }
}
